@echo off
SET hactool="tools\hactool.exe"
SET heropatcher="tools\heropatcher.exe"
SET quickbms="tools\quickbms.exe"
SET unpack="tools\unreal_tournament_4.bms"
SET keys="keys.txt"
if exist "%~1" (
	if exist %keys% goto chooselang
	echo Error: Keys not found!
) else (
	echo Error: Unable to open the file!
)
goto end

:chooselang
set /p language="Choose a language (en-US, fr, it, de, es, pt-BR): "
if "%language%" == "en-US" goto main
if "%language%" == "fr" goto main
if "%language%" == "it" goto main
if "%language%" == "de" goto main
if "%language%" == "es" goto main
if "%language%" == "pt-BR" goto main
echo Error: Chose a valid language!
goto chooselang

:error
echo Error: Something went wrong!
goto end

:main
if NOT exist "%hactool%" (
	echo Error: hactool not found!
	goto end
)
if NOT exist "%heropatcher%" (
	echo Error: heropatcher not found!
	goto end
)
if NOT exist "%quickbms%" (
	echo Error: QuickBMS not found!
	goto end
)
if NOT exist "%unpack%" (
	echo Error: unreal_tournament_4.bms not found!
	goto end
)
%hactool% -k %keys% --intype=pfs0 --pfs0dir=hero_pfs0 %~1
if NOT exist "hero_pfs0\22fb962f18e36b557a984bf5b93fbe3c.nca" goto error
%hactool% -k %keys% --exefsdir=hero_exefs --romfsdir=hero_romfs "hero_pfs0\22fb962f18e36b557a984bf5b93fbe3c.nca"
%hactool% -k %keys% --romfsdir=hero_docs "hero_pfs0\9d3f141701e90beda8635260b5c6cbc6.nca"
%hactool% -k %keys% --romfsdir=hero_icon "hero_pfs0\dce222cfc75b6b834306f6a94244f796.nca"
copy "hero_icon\icon_Japanese.dat" "hero_icon.jpg"
if NOT exist "hero_romfs\HeroGame\Content\Paks\HeroGame-Switch.pak" goto error
%quickbms% -Y %unpack% "hero_romfs\HeroGame\Content\Paks\HeroGame-Switch.pak" "hero_temp"
if NOT exist "hero_temp\HeroGame\" goto error
xcopy "hero_temp\HeroGame\Content\L10N\%language%\GUI" "hero_temp\HeroGame\Content\GUI" /s /y
%heropatcher% -common -%language% "hero_temp\HeroGame\Content\GUI\Common\DataTable\GameText\DT_CommonText.uexp"
%heropatcher% -ingame -%language% "hero_temp\HeroGame\Content\GUI\Common\DataTable\GameText\DT_IngameText.uexp"
%heropatcher% -outgame -%language% "hero_temp\HeroGame\Content\GUI\Common\DataTable\GameText\DT_OutgameText.uexp"
%heropatcher% -story -%language% "hero_temp\HeroGame\Content\GUI\Common\DataTable\GameText\DT_StoryText.uexp"
del "hero_temp\HeroGame\ContentL10N\*" /S /Q
del "hero_romfs\HeroGame\Content\Paks\HeroGame-Switch.pak" /S /Q
xcopy "hero_temp" "hero_romfs" /s /y
ren "hero_romfs" "hero_patched_romfs"
del "hero_temp\*" /S /Q
echo Plus Ultra!

:end
pause
exit