//Hero Text Patcher by lucaboy

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define numberOfFiles 4
#define numberOfLangs 7
#define sizeOfFlag 10

const unsigned char flags[numberOfFiles][numberOfLangs][sizeOfFlag] = {
	{
		//common
		{ 0xD6, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE2, 0x29 }, //jap
		{ 0xD0, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE2, 0x29 }, //eng
		{ 0xD3, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE2, 0x29 }, //fra
		{ 0xD5, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE2, 0x29 }, //ita
		{ 0xCD, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE2, 0x29 }, //deu
		{ 0xD1, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE2, 0x29 }, //esp
		{ 0xDF, 0x29, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xE2, 0x29 }  //por
	},
	{
		//ingame
		{ 0x0A, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01 }, //jap
		{ 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01 }, //eng
		{ 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01 }, //fra
		{ 0x09, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01 }, //ita
		{ 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01 }, //deu
		{ 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01 }, //esp
		{ 0x0F, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x01 }  //por
	},
	{
		//outgame
		{ 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x05 }, //jap
		{ 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x05 }, //eng
		{ 0x0D, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x05 }, //fra
		{ 0x10, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x05 }, //ita
		{ 0x07, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x05 }, //deu
		{ 0x0B, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x05 }, //esp
		{ 0x0F, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x12, 0x05 }  //por
	},
	{
		//story
		{ 0x0F, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA9, 0x01 }, //jap
		{ 0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA9, 0x01 }, //eng
		{ 0x0C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA9, 0x01 }, //fra
		{ 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA9, 0x01 }, //ita
		{ 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA9, 0x01 }, //deu
		{ 0x0A, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA9, 0x01 }, //esp
		{ 0x14, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xA9, 0x01 }  //por
	}
};

void swapFlags(unsigned char *buffer, long size, int file, int language);

int main(int argc, char *argv[])
{
	FILE *uexp;
	int language, file;
	
    if(argc < 4) {
        printf("Error: Too few arguments!");
        return -1;
    }

    uexp = fopen(argv[3], "rb+");
    if(uexp == NULL) {
        printf("Error: Unable to open the file!");
        return -2;
    }
    
    if (strcmp(argv[1], "-common") == 0) {
        file = 0;
    }
    else if (strcmp(argv[1], "-ingame") == 0) {
		file = 1;
    }
    else if (strcmp(argv[1], "-outgame") == 0) {
		file = 2;
    }
    else if (strcmp(argv[1], "-story") == 0) {
		file = 3;
    }
    else {
        printf("Argument \"%s\" is not valid!", argv[1]);
        return -3;
    }
    
    if (strcmp(argv[2], "-en-US") == 0) {
        language = 1;
    }
    else if (strcmp(argv[2], "-fr") == 0) {
        language = 2;
    }
    else if (strcmp(argv[2], "-it") == 0) {
        language = 3;
    }
    else if (strcmp(argv[2], "-de") == 0) {
        language = 4;
    }
    else if (strcmp(argv[2], "-es") == 0) {
        language = 5;
    }
    else if (strcmp(argv[2], "-pt-BR") == 0) {
        language = 6;
    }
    else {
        printf("Argument \"%s\" is not valid!", argv[2]);
        return -4;
    }
    
    fseek(uexp, 0, SEEK_END);
	long size = ftell(uexp);
	fseek(uexp, 0, SEEK_SET);
	unsigned char *buffer = malloc(size);
	if(buffer == NULL) {
		printf("Something went wrong!");
		return -5;
	}
	fread(buffer, 1, size, uexp);
	fseek(uexp, 0, SEEK_SET);
    swapFlags(buffer, size, language, file);
    fwrite(buffer, 1, size, uexp);
    free(buffer);
    fclose(uexp);
    printf("Done!");
    return 0;
}

void swapFlags(unsigned char *buffer, long size, int language, int file) {
	int offset = 0, index = 0, rotation = 0;
	for(; offset < size; offset++) {
		if(buffer[offset] == flags[file][language * (rotation % 2)][index]) {
			index++;
			if(index == sizeOfFlag) {
				memcpy(&buffer[offset - (sizeOfFlag - 1)], flags[file][language * ((rotation + 1) % 2)], sizeOfFlag);
				index = 0;
				rotation++;
			}
		}
		else{
			index = 0;
		}
	}
}
